// Camera.h
// Declaration of the camera class that manages the camera.

#ifndef _CAMERA_H
#define _CAMERA_H

#include <gl/glut.h>
#include "genericPoly.h"
#include "bunnyController.h"

class myCamera {

public:
	myCamera();
	~myCamera();
	int SetPosition(float x, float y, float z);
	int SetTarget (float x, float y, float z);
	vector GetTarget(void) {return target;}
	vector GetPosition(void) {return position;}
	int DoTransformations(void);
	int AdjustHeadings(void);
	int BunnyFollow(int mode, bunnyController bunny);

private:
	vector position;
	vector destPosition;
	vector target;
	float heading;
	float pitch;
	float getAngle(float x, float y);
};

#include "camera.cpp"

#endif